rem     PROGRAM D15


        ver$ = " 1.0"

rem     laatste wijziging: 20 juni 2003

rem     Dit programma berekent de parameters C-index, S-index en Angle 
rem     voor zowel de standaard als de desatur Farnsworth D15 test.


        dim u(15),v(15),c%(15)


        color 7,0                             

10      cls
        locate 5,13
        print "D15 ";ver$
        locate 5,50
        print "(c) Nomdo Jansonius"
        locate 7,18
        print "program for analysing the Farnsworth D-15 test"
        for i% = 8 to 73
          locate 9,i%
          print chr$(196)
        next i%   
        locate 13,1
        print "                      standard D-15                    (1)"
        print "                      desaturated D-15                 (2)"
        print "                      interpretation                   (3)"
        print "                      some info and help               (4)"
        print "                      exit                             (5)"
        gosub 940
        locate 21,13
        input "keuze ";keuze$
        if keuze$ = "1" then goto 12
        if keuze$ = "2" then goto 14
        if keuze$ = "3" then goto 910
        if keuze$ = "4" or keuze$ = "h" then goto 900
        if keuze$ = "5" or keuze$ = "e" then goto 990 else goto 10
12      te% = 1
        goto 20
14      te% = 2
        goto 20

20      if te% = 1 then restore 500
        if te% = 2 then restore 600
        for i% = 0 to 15
          read u(i%),v(i%)
        next i%   

110     cls
        locate 3,5
        print "enter cap numbers from left to right (exit: Ctrl c)"
        locate 5,7
        print "position 1    cap number P
        for i% = 1 to 15 
          locate i%+5,15
          print using "##";i%+1
120       locate i%+5,30
          input c%(i%)
          locate i%+5,30
          print "      "
          locate i%+5,31
          print using "##";c%(i%)
          if c%(i%) > 0 and c%(i%) <= 15 then 
            goto 150 
          else 
            locate i%+5,30
            print "      "
            goto 120
          end if
150       for j% = 1 to i%-1
            if c%(j%) <> c%(i%) then goto 200
            locate i%+5,40
            print "repeated entry!"
            locate 23,5
            print "type 1 to correct cap value, 2 to start again"
180         locate 23,54
            input keuze$
            if keuze$ = "1" then 
              locate i%+5,30
              print "                                   "
              locate 23,5
              print "                                                       "
              goto 120
            end if
            if keuze$ = "2" then 
              goto 110 
            else 
              locate 23,54
              print "      "
              goto 180
            end if
200       next j%
        next i%

        c%(0) = 0
        u2 = 0
        v2 = 0
        uv = 0
        for i% = 1 to 15
          du = u(c%(i%))-u(c%(i%-1))
          dv = v(c%(i%))-v(c%(i%-1))
          u2 = u2+du*du
          v2 = v2+dv*dv
          uv = uv+du*dv
        next i%
        d = u2-v2
        if d = 0 then a0 = .7854 else a0 = atn(2*uv/d)/2
        i0 = u2*sin(a0)*sin(a0)+v2*cos(a0)*cos(a0)-2*uv*sin(a0)*cos(a0)
        if a0 < 0 then a1 = a0+1.5708 else a1 = a0-1.5708
        i1 = u2*sin(a1)*sin(a1)+v2*cos(a1)*cos(a1)-2*uv*sin(a1)*cos(a1)
        if i0 > i1 then goto 340
        p = a0
        a0 = a1
        a1 = p
        p = i0
        i0 = i1
        i1 = p
340     r0 = sqr(i0/15)
        r1 = sqr(i1/15)
        r = sqr(r0*r0+r1*r1)
        if te% = 1 then r2 = 9.234669
        if te% = 2 then r2 = 5.121259
        if te% = 1 then 
          locate 3,67
          print "STANDARD"
        end if
        if te% = 2 then 
          locate 3,64
          print "DESATURATED"
        end if
        locate 10,50
        print "C-index"
        locate 10,62
        print using "##.##";r0/r2
        locate 12,50
        print "S-index"
        locate 12,62
        print using "##.##";r0/r1
        locate 14,50
        print "Angle ()"
        locate 14,62
        print using "###.#";57.3*a1
        gosub 950
        locate 23,46
        print "press any key to continue ..."
        do 
        loop while inkey$ = ""
        goto 10

500     data -21.54,-38.39
        data -23.26,-25.56,-22.41,-15.53,-23.11, -7.45
        data -22.45,  1.10,-21.67,  7.35,-14.08, 18.74
        data  -2.72, 28.13, 14.84, 31.13, 23.87, 26.35
        data  31.82, 14.76, 31.42,  6.99, 29.79,  0.10
        data  26.64, -9.38, 22.92,-18.65, 11.20,-24.61

600     data  -4.77,-16.63
        data  -8.63,-14.65,-12.08,-11.94,-12.86, -6.74
        data -12.26, -2.67,-11.18,  2.01, -7.02,  9.12
        data   1.30, 15.78,  9.90, 16.46, 15.03, 12.05
        data  15.48,  2.56, 14.76, -2.24, 13.56, -5.04
        data  11.06, -9.17,  8.95,-12.39,  5.62,-15.20

900     cls
        locate 3,1
        print "----------------------------------------------------"
        print " This program is based on the article:              "
        print "                                                    "
        print " Vingrys AJ, King-Smith PE (1988) A quantitative    "
        print " scoring technique for panel tests of color vision. "
        print " Invest Ophthalmol Vis Sci 29: 50-63.               "
        print "----------------------------------------------------"
        print " The program calculates the parameters C-index,     "
        print " S-index, and Angle for both the standard and the   "
        print " desaturated Farnsworth D-15 test.                  "
        print "----------------------------------------------------"
        locate 23,46
        print "press any key to continue ..."
        do 
        loop while inkey$ = ""
        goto 10

910     cls
        locate 3,1
        print "----------------------------------------------------"
        print " Results for the standard D-15 test from Vingrys    "
        print " and King-Smith:                                    "
        print "                                                    "
        print "               C-index     S-index     Angle ()    "
        print "                                                    "
        print " no errors       1.0        1.38        62          "
        print "                                                    "
        print " protanopes      4.2        6.2         19          "
        print " protanomales    2.0        2.0         28          "
        print "                                                    "
        print " deuteranopes    4.1        6.2         -7          "
        print " deuteranomals   2.8        3.0         -6          "
        print "                                                    "
        print " tritans         2.6        3.9        -83          "
        print "----------------------------------------------------"
        print " AZG: C-index standard :  mean 1.?    range 1.0-?.? "
        print "      desaturated      :       1.?          1.0-?.? "
        print "----------------------------------------------------"
        locate 23,46
        print "press any key to continue ..."
        do 
        loop while inkey$ = ""
        goto 10

940     for i% = 7 to 74
          locate 3,i%
          print chr$(205)
          locate 23,i%
          print chr$(205)
        next i%
        for i% = 3 to 23
          locate i%,7
          print chr$(186)
          locate i%,74
          print chr$(186)
        next i%
        locate 3,7
        print chr$(201)
        locate 3,74
        print chr$(187)
        locate 23,7
        print chr$(200)
        locate 23,74
        print chr$(188)
        return

950     for i% = 46 to 70
          locate 8,i%
          print chr$(205)
          locate 16,i%
          print chr$(205)
        next i%
        for i% = 8 to 16
          locate i%,46
          print chr$(186)
          locate i%,70
          print chr$(186)
        next i%
        locate 8,46
        print chr$(201)
        locate 8,70
        print chr$(187)
        locate 16,46
        print chr$(200)
        locate 16,70
        print chr$(188)
        return

990     color 7,0
        cls
        locate 15,1
        print "D15 collapsed to DOS"
        locate 20,1
999     end
